Summary:        LMDB Abstraction Layer
Name:           lmdbal
License:        GPL-3.0-only

Version:        0.5.4
Release:        1%{?dist}

URL:            https://git.macaw.me/blue/lmdbal
Source:         %{url}/archive/%{version}.tar.gz
# Generate only man pages
Patch:          doc.patch

BuildRequires:  cmake
BuildRequires:  doxygen
BuildRequires:  gcc-c++
BuildRequires:  gtest-devel
BuildRequires:  make
BuildRequires:  lmdb-devel
BuildRequires:  qt5-qtbase-devel

%global _description %{expand:
A library to ease interactions with LMDB.}

%description
%_description

%package devel
Summary:        LMDB Abstraction Layer
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
%_description


%prep
%autosetup -p 1 -n %{name}

%build
# Use Qt5 for now as main dependency squawk currently uses Qt5
%cmake -DBUILD_STATIC=False \
       -DBUILD_TESTS=True \
       -DBUILD_DOC=True \
       -DQT_VERSION_MAJOR=5

%cmake_build

%install
%cmake_install
# Move documentation into correct location
mkdir -p %{buildroot}%{_mandir}
mv %{buildroot}/usr/share/doc/LMDBAL/man/man3 %{buildroot}%{_mandir}/

%check
# Run tests
%{_builddir}/%{name}/%{_vpath_builddir}/test/runUnitTests

%files
%license LICENSE.md
%doc README.md
%doc CHANGELOG.md
%{_libdir}/libLMDBAL.so.1
%{_mandir}/man3/LMDBAL_Base.3*
%{_mandir}/man3/LMDBAL_Cache.3*
%{_mandir}/man3/LMDBAL_Closed.3*
%{_mandir}/man3/LMDBAL_Cursor.3*
%{_mandir}/man3/LMDBAL_CursorEmpty.3*
%{_mandir}/man3/LMDBAL_CursorNotReady.3*
%{_mandir}/man3/LMDBAL_Directory.3*
%{_mandir}/man3/LMDBAL_Exception.3*
%{_mandir}/man3/LMDBAL_Exist.3*
%{_mandir}/man3/LMDBAL_iStorage.3*
%{_mandir}/man3/LMDBAL_NotFound.3*
%{_mandir}/man3/LMDBAL_Opened.3*
%{_mandir}/man3/LMDBAL_Serializer.3*
%{_mandir}/man3/LMDBAL_Serializer_\ double\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ float\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int16_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int32_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int64_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ int8_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ QByteArray\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ QString\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ std_string\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint16_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint32_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint64_t\ _.3*
%{_mandir}/man3/LMDBAL_Serializer_\ uint8_t\ _.3*
%{_mandir}/man3/LMDBAL_Storage.3*
%{_mandir}/man3/LMDBAL_StorageDuplicate.3*
%{_mandir}/man3/LMDBAL_Transaction.3*
%{_mandir}/man3/LMDBAL_TransactionTerminated.3*
%{_mandir}/man3/LMDBAL_Unknown.3*
%{_mandir}/man3/LMDBAL_WriteTransaction.3*


%files devel
%{_libdir}/libLMDBAL.so
%dir %{_libdir}/cmake/%{name}
%{_libdir}/cmake/%{name}/*.cmake
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/*.hpp


%changelog
* Tue Oct 1 2024 Benson Muite <benson_muite@emailplus.org> - 0.11.1-1
- Initial package
